//+------------------------------------------------------------------+
//|                                          !Retracement Finder.mq4 |
//|                                  Copyright  2011, John Wustrack |
//|                                        john_wustrack@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, John Wustrack"
#property link      "john_wustrack@hotmail.com"

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1 LightGray
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern bool xb_Alert = false;
extern int xi_Period = 4;
extern int xi_Alert.Bar = 0;

double IB_Wait[];
double IB_Bull[];
double IB_Bear[];
double IB_CCI[];

string gs_Ind.Name;
datetime gdt_Last.Alert;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(0,IB_Wait);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,IB_Bull);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,IB_Bear);
   SetIndexBuffer(3,IB_CCI);
   IndicatorDigits(Digits-1);
   gs_Ind.Name = "Retracement Finder - (" + xi_Period + ")";
   IndicatorShortName(gs_Ind.Name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   int    counted_bars=IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars-counted_bars;
   double ld_CCI;
   
   for (int i=limit; i>=0; i--)
      {
      IB_Wait[i]=EMPTY_VALUE;
      IB_Bull[i]=EMPTY_VALUE;
      IB_Bear[i]=EMPTY_VALUE;
      
      ld_CCI = iCCI(NULL,0,xi_Period,PRICE_TYPICAL,i);
      IB_CCI[i] = ld_CCI;
         if (ld_CCI > 0 && IB_CCI[i+1] < 0)
            IB_Bull[i] = ld_CCI;
         else
            if (ld_CCI < 0 && IB_CCI[i+1] > 0)
               IB_Bear[i] = ld_CCI;
            else
               IB_Wait[i] = ld_CCI; 
                  
      }
      
   if (!xb_Alert) return(0);
   
   if (gdt_Last.Alert == Time[0]) return(0);
      
   // Bullish Alert    
   if (IB_Bull[xi_Alert.Bar] != EMPTY_VALUE)
      {
      Alert(Symbol(),Period()," Possible BULLISH trade at ",TimeToStr(Time[0],TIME_DATE|TIME_MINUTES));
      gdt_Last.Alert = Time[0];
      }
   
   // Bearish Alert 
   if (IB_Bear[xi_Alert.Bar] != EMPTY_VALUE)
      {
      Alert(Symbol(),Period()," Possible BEARISH trade at ",TimeToStr(Time[0],TIME_DATE|TIME_MINUTES));
      gdt_Last.Alert = Time[0];
      }
      
   
   
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| convert to points                                                |
//+------------------------------------------------------------------+
double Convert_2_Pts(double pd_Pips)
  {
//----
   int pd_Points=pd_Pips;  // Default - no conversion
   
 	if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1)) 
 	   pd_Points=pd_Pips*10;
 	   
 	if (Digits == 6 || (Digits == 4 && StringFind(Symbol(), "JPY") != -1)) 
 	   pd_Points=pd_Pips*100;
//----
   return(pd_Points);
  }
//+------------------------------------------------------------------+